From c3ea33aeed6db59bf5c31b0fa997171378939e1f Mon Sep 17 00:00:00 2001
From: Shaily <shaily15297@yahoo.com>
Date: Feb 05 2018 14:33:19 +0000
Subject: [PATCH 20/32] Issues: Update cache invalidation


---

diff --git a/hubs/widgets/issues/functions.py b/hubs/widgets/issues/functions.py
index cf34813..c71b50e 100644
--- a/hubs/widgets/issues/functions.py
+++ b/hubs/widgets/issues/functions.py
@@ -36,9 +36,11 @@ class GetBugzillaBugs(CachedFunction):
         if message['topic'].endswith('bugzilla.bug.new') or \
            message['topic'].endswith('bugzilla.bug.update'):
             return message['msg']['bug']['creator' if mode == 'author' else 'assigned_to'] == email
-
-    def should_invalidate_on_hub_config_change(self, old_config):
-        return old_config['bugzilla_email'] != self.instance.hub.config['bugzilla_email']
+        elif message["topic"].endswith('.hubs.hub.updated'):
+            if message['msg']['hub_id'] == self.instance.hub.id:
+                return 'bugzilla_email' in message['msg']['changed_keys']
+        else:
+            return False
 
 
 class GetPagureIssues(CachedFunction):
@@ -74,9 +76,11 @@ class GetPagureIssues(CachedFunction):
            message['topic'].endswith('pagure.issue.drop'):
             entry = message['msg']['issue']['user' if mode == 'author' else 'assignee']
             return entry and entry['name'] == username
-
-    def should_invalidate_on_hub_config_change(self, old_config):
-        return old_config['pagure_username'] != self.instance.hub.config['pagure_username']
+        elif message["topic"].endswith('.hubs.hub.updated'):
+            if message['msg']['hub_id'] == self.instance.hub.id:
+                return 'pagure_username' in message['msg']['changed_keys']
+        else:
+            return False
 
 
 class GetGithubIssues(CachedFunction):
@@ -110,6 +114,8 @@ class GetGithubIssues(CachedFunction):
            message['topic'].endswith('github.issue.closed'):
             entry = message['msg']['issue']['user' if mode == 'author' else 'assignee']
             return entry and entry['login'] == username
-
-    def should_invalidate_on_hub_config_change(self, old_config):
-        return old_config['github_username'] != self.instance.hub.config['github_username']
+        elif message["topic"].endswith('.hubs.hub.updated'):
+            if message['msg']['hub_id'] == self.instance.hub.id:
+                return 'github_username' in message['msg']['changed_keys']
+        else:
+            return False

